local text = this.getText(node)

function count_characters_and_words(text)
    local lines = {}
    local total_characters = 0
    local total_words = 0
    local capital_letters = {}
    local small_letters = {}
    local symbols = {}
    local example_words = {}
    local example_symbols = {}
    local total_numbers = 0
    local example_numbers = {}

    local line_number = 1

    for line in text:gmatch("[^\r\n]+") do
        local character_count = utf8.len(line)
        total_characters = total_characters + character_count
        local words = {}

        for word in line:gmatch("%S+") do
            words[#words + 1] = word
            example_words[#example_words + 1] = word

            for letter in word:gmatch(".") do
                if letter:match("%u") then
                    local letter_as_string = letter:match("%u")
                    if not capital_letters[letter_as_string] then
                        capital_letters[letter_as_string] = true
                    end
                elseif letter:match("%l") then
                    local letter_as_string = letter:match("%l")
                    if not small_letters[letter_as_string] then
                        small_letters[letter_as_string] = true
                    end
                else
                    local letter_as_string = letter
                    if not symbols[letter_as_string] and not letter:match("%d") then
                        symbols[letter_as_string] = true
                        example_symbols[#example_symbols + 1] = letter_as_string
                    end

                    if letter:match("%d") then
                        local number = tonumber(letter)
                        if number then
                            total_numbers = total_numbers + 1
                            example_numbers[#example_numbers + 1] = number
                        end
                    end
                end
            end
        end
        total_words = total_words + #words
        local line_text = "Line " .. line_number .. ": " .. character_count .. " character" .. (character_count > 1 and "s" or "") .. ", " .. line
        lines[#lines + 1] = line_text
        line_number = line_number + 1
    end

    local sorted_capital_letters = {}
    for letter, _ in pairs(capital_letters) do
        table.insert(sorted_capital_letters, letter)
    end
    table.sort(sorted_capital_letters)

    local sorted_small_letters = {}
    for letter, _ in pairs(small_letters) do
        table.insert(sorted_small_letters, letter)
    end
    table.sort(sorted_small_letters)

    local sorted_symbols = {}
    for letter, _ in pairs(symbols) do
        table.insert(sorted_symbols, letter)
    end
    table.sort(sorted_symbols)

    print("Total characters: " .. total_characters)

    local total_words_text = "Total words: " .. total_words
    if total_words > 0 then
        total_words_text = total_words_text .. " ("
        for i, word in ipairs(example_words) do
            total_words_text = total_words_text .. word
            if i < #example_words then
                total_words_text = total_words_text .. ", " -- Ilagay ang kama sa pagitan ng mga words
            end
        end
        total_words_text = total_words_text .. ")"
    end
    print(total_words_text)

    print("Total capital letters: " .. (next(capital_letters) and table.concat(sorted_capital_letters, ", ") or "zero"))
    print("Total small letters: " .. (next(small_letters) and table.concat(sorted_small_letters, ", ") or "zero"))

    local total_symbols_text = "Total symbols: " .. #sorted_symbols
    if #sorted_symbols > 0 then
        total_symbols_text = total_symbols_text .. " ("
        for i, symbol in ipairs(example_symbols) do
            total_symbols_text = total_symbols_text .. symbol
            if i < #example_symbols then
                total_symbols_text = total_symbols_text .. " "
            end
        end
        total_symbols_text = total_symbols_text .. ")"
    end
    print(total_symbols_text)

    local total_numbers_text = "Total numbers: " .. total_numbers
    if total_numbers > 0 then
        total_numbers_text = total_numbers_text .. " ("
        for i, number in ipairs(example_numbers) do
            total_numbers_text = total_numbers_text .. number
            if i < #example_numbers then
                total_numbers_text = total_numbers_text .. " "
            end
        end
        total_numbers_text = total_numbers_text .. ")"
    end
    print(total_numbers_text)

    for i, line in ipairs(lines) do
        print(line)
    end
end

count_characters_and_words(text)